from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, Int

Gtftk_Discretize_Key_V0_1_0 = CommandToolBuilder(tool="gtftk_discretize_key", base_command=["gtftk", "discretize_key"], inputs=[ToolInput(tag="in_input_file", input_type=Boolean(optional=True), prefix="--inputfile", doc=InputDocumentation(doc="Path to the GTF file. Default to STDIN (default: <stdin>)")), ToolInput(tag="in_output_file", input_type=File(optional=True), prefix="--outputfile", doc=InputDocumentation(doc="Output file. (default: <stdout>)")), ToolInput(tag="in_src_key", input_type=Boolean(optional=True), prefix="--src-key", doc=InputDocumentation(doc="The name of the source key (default: None)")), ToolInput(tag="in_dest_key", input_type=Boolean(optional=True), prefix="--dest-key", doc=InputDocumentation(doc="The name of the target key. (default: None)")), ToolInput(tag="in_nb_levels", input_type=Boolean(optional=True), prefix="--nb-levels", doc=InputDocumentation(doc="The number of levels/classes to create. (default: 2)")), ToolInput(tag="in_labels", input_type=Boolean(optional=True), prefix="--labels", doc=InputDocumentation(doc="A comma-separated list of labels of size --nb-levels. (default: None)")), ToolInput(tag="in_percentiles", input_type=Boolean(optional=True), prefix="--percentiles", doc=InputDocumentation(doc="Compute --nb-levels classes using percentiles. (default: False)")), ToolInput(tag="in_log", input_type=Boolean(optional=True), prefix="--log", doc=InputDocumentation(doc="Compute breaks based on log-scale. (default: False)")), ToolInput(tag="in_percentiles_of_uniq", input_type=Boolean(optional=True), prefix="--percentiles-of-uniq", doc=InputDocumentation(doc="Compute percentiles based on non-redondant values. (default: False)")), ToolInput(tag="in_precision", input_type=Boolean(optional=True), prefix="--precision", doc=InputDocumentation(doc="The precision used in naming intervals. (default: 2)")), ToolInput(tag="in_verbosity", input_type=Boolean(optional=True), prefix="--verbosity", doc=InputDocumentation(doc="Set output verbosity ([0-3]). (default: 0)")), ToolInput(tag="in_no_date", input_type=File(optional=True), prefix="--no-date", doc=InputDocumentation(doc="Do not add date to output file names. (default: False)")), ToolInput(tag="in_add_chr", input_type=Boolean(optional=True), prefix="--add-chr", doc=InputDocumentation(doc="Add 'chr' to chromosome names before printing output. (default: False)")), ToolInput(tag="in_tmp_dir", input_type=Boolean(optional=True), prefix="--tmp-dir", doc=InputDocumentation(doc="Keep all temporary files into this folder. (default: None)")), ToolInput(tag="in_keep_all", input_type=Boolean(optional=True), prefix="--keep-all", doc=InputDocumentation(doc="Try to keep all temporary files even if process does not terminate normally. (default: False)")), ToolInput(tag="in_logger_file", input_type=Boolean(optional=True), prefix="--logger-file", doc=InputDocumentation(doc="Stores the arguments passed to the command into a file. (default: None)")), ToolInput(tag="in_write_message_to_file", input_type=Boolean(optional=True), prefix="--write-message-to-file", doc=InputDocumentation(doc="Store all message into a file. (default: None)")), ToolInput(tag="in_arguments", input_type=Int(), position=0, doc=InputDocumentation(doc="Arguments:"))], outputs=[ToolOutput(tag="out_output_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file", type_hint=File()), doc=OutputDocumentation(doc="Output file. (default: <stdout>)")), ToolOutput(tag="out_no_date", output_type=File(optional=True), selector=InputSelector(input_to_select="in_no_date", type_hint=File()), doc=OutputDocumentation(doc="Do not add date to output file names. (default: False)"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Gtftk_Discretize_Key_V0_1_0().translate("wdl", allow_empty_container=True)

